type exp = 
  CoreML.t =
    Var of Strng.t
  | Con of Strng.t
  | App of (exp * exp)
  | Abs of (Strng.t * exp)
  | Let of (Strng.t * exp * exp)
  | Ite of (exp * exp * exp)
type typ =
    TVar of int
  | TFun of (typ * typ)
  | TCon of (Strng.t * typ list)
val con : string -> exp
val tvar : int -> typ
val tcon : string -> typ list -> typ
val tint : typ
val tbool : typ
val tlist : typ -> typ
val tpair : typ * typ -> typ
val ( @-> ) : typ -> typ -> typ
val p : (exp * typ) list
val pmu : (exp * typ) list
val dom : ('a * 'b) list -> 'a list
val lookup : 'a -> 'b -> ('a * 'b) Lst.t -> 'b
val sub : (int * typ) Lst.t -> typ -> typ
val tvars : typ -> int St.t
val max_tvar : typ -> int
val to_up : (exp * typ) Lst.t * exp * typ -> (typ * typ) list
val ( <*> ) : (int * typ) Lst.t -> (int * typ) Lst.t -> (int * typ) list
val step : typ * typ -> (typ * typ) Lst.t * (int * typ) list
val unify : (typ * typ) list -> (int * typ) Lst.t
val infer : string -> typ
val toplevel_printer : Format.formatter -> typ -> unit
val toplevel_printer_list : Format.formatter -> typ list -> unit
val up1 : (typ * typ) list
val up2 : (typ * typ) list
val up3 : (typ * typ) list
val up4 : (typ * typ) list
